#define link 5
#define sol 4
long t=0;
bool rise=true;
bool start=false;

int latching=0;

void setup() { 
  // setting up connections
  Serial.begin(9600);
  pinMode(link,INPUT_PULLUP);
  pinMode(sol,OUTPUT);
  pinMode(LED_BUILTIN,OUTPUT);
  
  digitalWrite(LED_BUILTIN,LOW);
  digitalWrite(sol,LOW);
 
}

void loop() {
 //reading latching time value
 latching=analogRead(A0);
 latching=(long)latching*1060/1023; // convert the potentiometer read to a [ms] value (A0 goes from 0 to 1023) (choose the value of 
                                    // upper scale as double the optimal [ms] latching time
 Serial.println(latching);
 
 //detecting a rising edge
 if(digitalRead(link)==HIGH && rise){
  t=millis();
  start=true;
  rise=false;
  digitalWrite(LED_BUILTIN,HIGH);
 }
 if(digitalRead(link)==LOW && !rise){
  rise=true;
  digitalWrite(LED_BUILTIN,LOW);
 }
 
 //actuating the solenoid
 if(start && millis()-t>=250){ // put the time the wave takes to travel from the wedge to the Point Absorber
  digitalWrite(sol,HIGH);
  delay(latching);
  digitalWrite(sol,LOW);
  start=false;
 }
 delay(5);
}
